import codewars_test as test
from solution import brainfuck_to_c


def testing(code, expected):
    result = brainfuck_to_c(code)
    test.assert_equals(result, expected)
    
test.describe("general tests")

test.it("thib")
testing("-+-+", "")
testing("<>", "")
#testing(">>><<<<", "<")

test.it("basic")
testing("+-", "")
testing("++++", "*p += 4;\n")
testing("----", "*p -= 4;\n")

testing(">>>>", "p += 4;\n");
testing("<<<<", "p -= 4;\n");
    
testing(".", "putchar(*p);\n");
testing(",", "*p = getchar();\n");
    
testing("[[[]]", "Error!");
    
testing("[][]", "");
    
testing("[.]", "if (*p) do {\n  putchar(*p);\n} while (*p);\n");

